//
// Copyright (C) 2020, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private BigTrade[] cacheBigTrade = null;

        private static BigTrade checkBigTrade = new BigTrade();

        /// <summary>
        /// ForexAndCodes BigTrade for NinjaTrader
        /// </summary>
        /// <returns></returns>
        public BigTrade BigTrade(string alertaEmail_EmailDestino, bool alertaNuevoBigTradeEmail, bool alertaNuevoBigTradePantalla, Color colorBigTradeDeltaNegativo, Color colorBigTradeDeltaPositivo, int contratosTamanoFuente, String desdeHora, int diasAVisualizar, int filtrarContratosMenores, bool modoNuevosMaximos, bool modoNuevosMaximosSesion, bool mostrarContratosDelta, Color nivelRepetidoColor, bool nivelRepetidoMarcar, double nivelRepetidoTolerancia, bool pintarLineaUltimoBigTrade, Color pintarLineaUltimoBigTradeColor, int pintarLineaUltimoBigTradeGrosor, bool pintarSegundoBt, double pintarSegundoBtTolerancia, Color segundoBigTradeColor, bool usarDeltaVela, String usuarioNombre, String usuarioPassword)
        {
            return BigTrade(Input, alertaEmail_EmailDestino, alertaNuevoBigTradeEmail, alertaNuevoBigTradePantalla, colorBigTradeDeltaNegativo, colorBigTradeDeltaPositivo, contratosTamanoFuente, desdeHora, diasAVisualizar, filtrarContratosMenores, modoNuevosMaximos, modoNuevosMaximosSesion, mostrarContratosDelta, nivelRepetidoColor, nivelRepetidoMarcar, nivelRepetidoTolerancia, pintarLineaUltimoBigTrade, pintarLineaUltimoBigTradeColor, pintarLineaUltimoBigTradeGrosor, pintarSegundoBt, pintarSegundoBtTolerancia, segundoBigTradeColor, usarDeltaVela, usuarioNombre, usuarioPassword);
        }

        /// <summary>
        /// ForexAndCodes BigTrade for NinjaTrader
        /// </summary>
        /// <returns></returns>
        public BigTrade BigTrade(Data.IDataSeries input, string alertaEmail_EmailDestino, bool alertaNuevoBigTradeEmail, bool alertaNuevoBigTradePantalla, Color colorBigTradeDeltaNegativo, Color colorBigTradeDeltaPositivo, int contratosTamanoFuente, String desdeHora, int diasAVisualizar, int filtrarContratosMenores, bool modoNuevosMaximos, bool modoNuevosMaximosSesion, bool mostrarContratosDelta, Color nivelRepetidoColor, bool nivelRepetidoMarcar, double nivelRepetidoTolerancia, bool pintarLineaUltimoBigTrade, Color pintarLineaUltimoBigTradeColor, int pintarLineaUltimoBigTradeGrosor, bool pintarSegundoBt, double pintarSegundoBtTolerancia, Color segundoBigTradeColor, bool usarDeltaVela, String usuarioNombre, String usuarioPassword)
        {
            if (cacheBigTrade != null)
                for (int idx = 0; idx < cacheBigTrade.Length; idx++)
                    if (cacheBigTrade[idx].AlertaEmail_EmailDestino == alertaEmail_EmailDestino && cacheBigTrade[idx].AlertaNuevoBigTradeEmail == alertaNuevoBigTradeEmail && cacheBigTrade[idx].AlertaNuevoBigTradePantalla == alertaNuevoBigTradePantalla && cacheBigTrade[idx].ColorBigTradeDeltaNegativo == colorBigTradeDeltaNegativo && cacheBigTrade[idx].ColorBigTradeDeltaPositivo == colorBigTradeDeltaPositivo && cacheBigTrade[idx].ContratosTamanoFuente == contratosTamanoFuente && cacheBigTrade[idx].DesdeHora == desdeHora && cacheBigTrade[idx].DiasAVisualizar == diasAVisualizar && cacheBigTrade[idx].FiltrarContratosMenores == filtrarContratosMenores && cacheBigTrade[idx].ModoNuevosMaximos == modoNuevosMaximos && cacheBigTrade[idx].ModoNuevosMaximosSesion == modoNuevosMaximosSesion && cacheBigTrade[idx].MostrarContratosDelta == mostrarContratosDelta && cacheBigTrade[idx].NivelRepetidoColor == nivelRepetidoColor && cacheBigTrade[idx].NivelRepetidoMarcar == nivelRepetidoMarcar && Math.Abs(cacheBigTrade[idx].NivelRepetidoTolerancia - nivelRepetidoTolerancia) <= double.Epsilon && cacheBigTrade[idx].PintarLineaUltimoBigTrade == pintarLineaUltimoBigTrade && cacheBigTrade[idx].PintarLineaUltimoBigTradeColor == pintarLineaUltimoBigTradeColor && cacheBigTrade[idx].PintarLineaUltimoBigTradeGrosor == pintarLineaUltimoBigTradeGrosor && cacheBigTrade[idx].PintarSegundoBt == pintarSegundoBt && Math.Abs(cacheBigTrade[idx].PintarSegundoBtTolerancia - pintarSegundoBtTolerancia) <= double.Epsilon && cacheBigTrade[idx].SegundoBigTradeColor == segundoBigTradeColor && cacheBigTrade[idx].UsarDeltaVela == usarDeltaVela && cacheBigTrade[idx].UsuarioNombre == usuarioNombre && cacheBigTrade[idx].UsuarioPassword == usuarioPassword && cacheBigTrade[idx].EqualsInput(input))
                        return cacheBigTrade[idx];

            lock (checkBigTrade)
            {
                checkBigTrade.AlertaEmail_EmailDestino = alertaEmail_EmailDestino;
                alertaEmail_EmailDestino = checkBigTrade.AlertaEmail_EmailDestino;
                checkBigTrade.AlertaNuevoBigTradeEmail = alertaNuevoBigTradeEmail;
                alertaNuevoBigTradeEmail = checkBigTrade.AlertaNuevoBigTradeEmail;
                checkBigTrade.AlertaNuevoBigTradePantalla = alertaNuevoBigTradePantalla;
                alertaNuevoBigTradePantalla = checkBigTrade.AlertaNuevoBigTradePantalla;
                checkBigTrade.ColorBigTradeDeltaNegativo = colorBigTradeDeltaNegativo;
                colorBigTradeDeltaNegativo = checkBigTrade.ColorBigTradeDeltaNegativo;
                checkBigTrade.ColorBigTradeDeltaPositivo = colorBigTradeDeltaPositivo;
                colorBigTradeDeltaPositivo = checkBigTrade.ColorBigTradeDeltaPositivo;
                checkBigTrade.ContratosTamanoFuente = contratosTamanoFuente;
                contratosTamanoFuente = checkBigTrade.ContratosTamanoFuente;
                checkBigTrade.DesdeHora = desdeHora;
                desdeHora = checkBigTrade.DesdeHora;
                checkBigTrade.DiasAVisualizar = diasAVisualizar;
                diasAVisualizar = checkBigTrade.DiasAVisualizar;
                checkBigTrade.FiltrarContratosMenores = filtrarContratosMenores;
                filtrarContratosMenores = checkBigTrade.FiltrarContratosMenores;
                checkBigTrade.ModoNuevosMaximos = modoNuevosMaximos;
                modoNuevosMaximos = checkBigTrade.ModoNuevosMaximos;
                checkBigTrade.ModoNuevosMaximosSesion = modoNuevosMaximosSesion;
                modoNuevosMaximosSesion = checkBigTrade.ModoNuevosMaximosSesion;
                checkBigTrade.MostrarContratosDelta = mostrarContratosDelta;
                mostrarContratosDelta = checkBigTrade.MostrarContratosDelta;
                checkBigTrade.NivelRepetidoColor = nivelRepetidoColor;
                nivelRepetidoColor = checkBigTrade.NivelRepetidoColor;
                checkBigTrade.NivelRepetidoMarcar = nivelRepetidoMarcar;
                nivelRepetidoMarcar = checkBigTrade.NivelRepetidoMarcar;
                checkBigTrade.NivelRepetidoTolerancia = nivelRepetidoTolerancia;
                nivelRepetidoTolerancia = checkBigTrade.NivelRepetidoTolerancia;
                checkBigTrade.PintarLineaUltimoBigTrade = pintarLineaUltimoBigTrade;
                pintarLineaUltimoBigTrade = checkBigTrade.PintarLineaUltimoBigTrade;
                checkBigTrade.PintarLineaUltimoBigTradeColor = pintarLineaUltimoBigTradeColor;
                pintarLineaUltimoBigTradeColor = checkBigTrade.PintarLineaUltimoBigTradeColor;
                checkBigTrade.PintarLineaUltimoBigTradeGrosor = pintarLineaUltimoBigTradeGrosor;
                pintarLineaUltimoBigTradeGrosor = checkBigTrade.PintarLineaUltimoBigTradeGrosor;
                checkBigTrade.PintarSegundoBt = pintarSegundoBt;
                pintarSegundoBt = checkBigTrade.PintarSegundoBt;
                checkBigTrade.PintarSegundoBtTolerancia = pintarSegundoBtTolerancia;
                pintarSegundoBtTolerancia = checkBigTrade.PintarSegundoBtTolerancia;
                checkBigTrade.SegundoBigTradeColor = segundoBigTradeColor;
                segundoBigTradeColor = checkBigTrade.SegundoBigTradeColor;
                checkBigTrade.UsarDeltaVela = usarDeltaVela;
                usarDeltaVela = checkBigTrade.UsarDeltaVela;
                checkBigTrade.UsuarioNombre = usuarioNombre;
                usuarioNombre = checkBigTrade.UsuarioNombre;
                checkBigTrade.UsuarioPassword = usuarioPassword;
                usuarioPassword = checkBigTrade.UsuarioPassword;

                if (cacheBigTrade != null)
                    for (int idx = 0; idx < cacheBigTrade.Length; idx++)
                        if (cacheBigTrade[idx].AlertaEmail_EmailDestino == alertaEmail_EmailDestino && cacheBigTrade[idx].AlertaNuevoBigTradeEmail == alertaNuevoBigTradeEmail && cacheBigTrade[idx].AlertaNuevoBigTradePantalla == alertaNuevoBigTradePantalla && cacheBigTrade[idx].ColorBigTradeDeltaNegativo == colorBigTradeDeltaNegativo && cacheBigTrade[idx].ColorBigTradeDeltaPositivo == colorBigTradeDeltaPositivo && cacheBigTrade[idx].ContratosTamanoFuente == contratosTamanoFuente && cacheBigTrade[idx].DesdeHora == desdeHora && cacheBigTrade[idx].DiasAVisualizar == diasAVisualizar && cacheBigTrade[idx].FiltrarContratosMenores == filtrarContratosMenores && cacheBigTrade[idx].ModoNuevosMaximos == modoNuevosMaximos && cacheBigTrade[idx].ModoNuevosMaximosSesion == modoNuevosMaximosSesion && cacheBigTrade[idx].MostrarContratosDelta == mostrarContratosDelta && cacheBigTrade[idx].NivelRepetidoColor == nivelRepetidoColor && cacheBigTrade[idx].NivelRepetidoMarcar == nivelRepetidoMarcar && Math.Abs(cacheBigTrade[idx].NivelRepetidoTolerancia - nivelRepetidoTolerancia) <= double.Epsilon && cacheBigTrade[idx].PintarLineaUltimoBigTrade == pintarLineaUltimoBigTrade && cacheBigTrade[idx].PintarLineaUltimoBigTradeColor == pintarLineaUltimoBigTradeColor && cacheBigTrade[idx].PintarLineaUltimoBigTradeGrosor == pintarLineaUltimoBigTradeGrosor && cacheBigTrade[idx].PintarSegundoBt == pintarSegundoBt && Math.Abs(cacheBigTrade[idx].PintarSegundoBtTolerancia - pintarSegundoBtTolerancia) <= double.Epsilon && cacheBigTrade[idx].SegundoBigTradeColor == segundoBigTradeColor && cacheBigTrade[idx].UsarDeltaVela == usarDeltaVela && cacheBigTrade[idx].UsuarioNombre == usuarioNombre && cacheBigTrade[idx].UsuarioPassword == usuarioPassword && cacheBigTrade[idx].EqualsInput(input))
                            return cacheBigTrade[idx];

                BigTrade indicator = new BigTrade();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlertaEmail_EmailDestino = alertaEmail_EmailDestino;
                indicator.AlertaNuevoBigTradeEmail = alertaNuevoBigTradeEmail;
                indicator.AlertaNuevoBigTradePantalla = alertaNuevoBigTradePantalla;
                indicator.ColorBigTradeDeltaNegativo = colorBigTradeDeltaNegativo;
                indicator.ColorBigTradeDeltaPositivo = colorBigTradeDeltaPositivo;
                indicator.ContratosTamanoFuente = contratosTamanoFuente;
                indicator.DesdeHora = desdeHora;
                indicator.DiasAVisualizar = diasAVisualizar;
                indicator.FiltrarContratosMenores = filtrarContratosMenores;
                indicator.ModoNuevosMaximos = modoNuevosMaximos;
                indicator.ModoNuevosMaximosSesion = modoNuevosMaximosSesion;
                indicator.MostrarContratosDelta = mostrarContratosDelta;
                indicator.NivelRepetidoColor = nivelRepetidoColor;
                indicator.NivelRepetidoMarcar = nivelRepetidoMarcar;
                indicator.NivelRepetidoTolerancia = nivelRepetidoTolerancia;
                indicator.PintarLineaUltimoBigTrade = pintarLineaUltimoBigTrade;
                indicator.PintarLineaUltimoBigTradeColor = pintarLineaUltimoBigTradeColor;
                indicator.PintarLineaUltimoBigTradeGrosor = pintarLineaUltimoBigTradeGrosor;
                indicator.PintarSegundoBt = pintarSegundoBt;
                indicator.PintarSegundoBtTolerancia = pintarSegundoBtTolerancia;
                indicator.SegundoBigTradeColor = segundoBigTradeColor;
                indicator.UsarDeltaVela = usarDeltaVela;
                indicator.UsuarioNombre = usuarioNombre;
                indicator.UsuarioPassword = usuarioPassword;
                Indicators.Add(indicator);
                indicator.SetUp();

                BigTrade[] tmp = new BigTrade[cacheBigTrade == null ? 1 : cacheBigTrade.Length + 1];
                if (cacheBigTrade != null)
                    cacheBigTrade.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheBigTrade = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// ForexAndCodes BigTrade for NinjaTrader
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.BigTrade BigTrade(string alertaEmail_EmailDestino, bool alertaNuevoBigTradeEmail, bool alertaNuevoBigTradePantalla, Color colorBigTradeDeltaNegativo, Color colorBigTradeDeltaPositivo, int contratosTamanoFuente, String desdeHora, int diasAVisualizar, int filtrarContratosMenores, bool modoNuevosMaximos, bool modoNuevosMaximosSesion, bool mostrarContratosDelta, Color nivelRepetidoColor, bool nivelRepetidoMarcar, double nivelRepetidoTolerancia, bool pintarLineaUltimoBigTrade, Color pintarLineaUltimoBigTradeColor, int pintarLineaUltimoBigTradeGrosor, bool pintarSegundoBt, double pintarSegundoBtTolerancia, Color segundoBigTradeColor, bool usarDeltaVela, String usuarioNombre, String usuarioPassword)
        {
            return _indicator.BigTrade(Input, alertaEmail_EmailDestino, alertaNuevoBigTradeEmail, alertaNuevoBigTradePantalla, colorBigTradeDeltaNegativo, colorBigTradeDeltaPositivo, contratosTamanoFuente, desdeHora, diasAVisualizar, filtrarContratosMenores, modoNuevosMaximos, modoNuevosMaximosSesion, mostrarContratosDelta, nivelRepetidoColor, nivelRepetidoMarcar, nivelRepetidoTolerancia, pintarLineaUltimoBigTrade, pintarLineaUltimoBigTradeColor, pintarLineaUltimoBigTradeGrosor, pintarSegundoBt, pintarSegundoBtTolerancia, segundoBigTradeColor, usarDeltaVela, usuarioNombre, usuarioPassword);
        }

        /// <summary>
        /// ForexAndCodes BigTrade for NinjaTrader
        /// </summary>
        /// <returns></returns>
        public Indicator.BigTrade BigTrade(Data.IDataSeries input, string alertaEmail_EmailDestino, bool alertaNuevoBigTradeEmail, bool alertaNuevoBigTradePantalla, Color colorBigTradeDeltaNegativo, Color colorBigTradeDeltaPositivo, int contratosTamanoFuente, String desdeHora, int diasAVisualizar, int filtrarContratosMenores, bool modoNuevosMaximos, bool modoNuevosMaximosSesion, bool mostrarContratosDelta, Color nivelRepetidoColor, bool nivelRepetidoMarcar, double nivelRepetidoTolerancia, bool pintarLineaUltimoBigTrade, Color pintarLineaUltimoBigTradeColor, int pintarLineaUltimoBigTradeGrosor, bool pintarSegundoBt, double pintarSegundoBtTolerancia, Color segundoBigTradeColor, bool usarDeltaVela, String usuarioNombre, String usuarioPassword)
        {
            return _indicator.BigTrade(input, alertaEmail_EmailDestino, alertaNuevoBigTradeEmail, alertaNuevoBigTradePantalla, colorBigTradeDeltaNegativo, colorBigTradeDeltaPositivo, contratosTamanoFuente, desdeHora, diasAVisualizar, filtrarContratosMenores, modoNuevosMaximos, modoNuevosMaximosSesion, mostrarContratosDelta, nivelRepetidoColor, nivelRepetidoMarcar, nivelRepetidoTolerancia, pintarLineaUltimoBigTrade, pintarLineaUltimoBigTradeColor, pintarLineaUltimoBigTradeGrosor, pintarSegundoBt, pintarSegundoBtTolerancia, segundoBigTradeColor, usarDeltaVela, usuarioNombre, usuarioPassword);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// ForexAndCodes BigTrade for NinjaTrader
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.BigTrade BigTrade(string alertaEmail_EmailDestino, bool alertaNuevoBigTradeEmail, bool alertaNuevoBigTradePantalla, Color colorBigTradeDeltaNegativo, Color colorBigTradeDeltaPositivo, int contratosTamanoFuente, String desdeHora, int diasAVisualizar, int filtrarContratosMenores, bool modoNuevosMaximos, bool modoNuevosMaximosSesion, bool mostrarContratosDelta, Color nivelRepetidoColor, bool nivelRepetidoMarcar, double nivelRepetidoTolerancia, bool pintarLineaUltimoBigTrade, Color pintarLineaUltimoBigTradeColor, int pintarLineaUltimoBigTradeGrosor, bool pintarSegundoBt, double pintarSegundoBtTolerancia, Color segundoBigTradeColor, bool usarDeltaVela, String usuarioNombre, String usuarioPassword)
        {
            return _indicator.BigTrade(Input, alertaEmail_EmailDestino, alertaNuevoBigTradeEmail, alertaNuevoBigTradePantalla, colorBigTradeDeltaNegativo, colorBigTradeDeltaPositivo, contratosTamanoFuente, desdeHora, diasAVisualizar, filtrarContratosMenores, modoNuevosMaximos, modoNuevosMaximosSesion, mostrarContratosDelta, nivelRepetidoColor, nivelRepetidoMarcar, nivelRepetidoTolerancia, pintarLineaUltimoBigTrade, pintarLineaUltimoBigTradeColor, pintarLineaUltimoBigTradeGrosor, pintarSegundoBt, pintarSegundoBtTolerancia, segundoBigTradeColor, usarDeltaVela, usuarioNombre, usuarioPassword);
        }

        /// <summary>
        /// ForexAndCodes BigTrade for NinjaTrader
        /// </summary>
        /// <returns></returns>
        public Indicator.BigTrade BigTrade(Data.IDataSeries input, string alertaEmail_EmailDestino, bool alertaNuevoBigTradeEmail, bool alertaNuevoBigTradePantalla, Color colorBigTradeDeltaNegativo, Color colorBigTradeDeltaPositivo, int contratosTamanoFuente, String desdeHora, int diasAVisualizar, int filtrarContratosMenores, bool modoNuevosMaximos, bool modoNuevosMaximosSesion, bool mostrarContratosDelta, Color nivelRepetidoColor, bool nivelRepetidoMarcar, double nivelRepetidoTolerancia, bool pintarLineaUltimoBigTrade, Color pintarLineaUltimoBigTradeColor, int pintarLineaUltimoBigTradeGrosor, bool pintarSegundoBt, double pintarSegundoBtTolerancia, Color segundoBigTradeColor, bool usarDeltaVela, String usuarioNombre, String usuarioPassword)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.BigTrade(input, alertaEmail_EmailDestino, alertaNuevoBigTradeEmail, alertaNuevoBigTradePantalla, colorBigTradeDeltaNegativo, colorBigTradeDeltaPositivo, contratosTamanoFuente, desdeHora, diasAVisualizar, filtrarContratosMenores, modoNuevosMaximos, modoNuevosMaximosSesion, mostrarContratosDelta, nivelRepetidoColor, nivelRepetidoMarcar, nivelRepetidoTolerancia, pintarLineaUltimoBigTrade, pintarLineaUltimoBigTradeColor, pintarLineaUltimoBigTradeGrosor, pintarSegundoBt, pintarSegundoBtTolerancia, segundoBigTradeColor, usarDeltaVela, usuarioNombre, usuarioPassword);
        }
    }
}
#endregion
